## znc 1.9.0

=== CMakeLists.txt ===
#
# Copyright (C) 2004-2024 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.13)
project(ZNC VERSION 1.9.0 LANGUAGES CXX)
set(ZNC_VERSION 1.9.0)
set(append_git_version false)
set(alpha_version "") # e.g. "-rc1"
set(VERSION_EXTRA "" CACHE STRING
	"Additional string appended to version, e.g. to mark distribution")

set(PROJECT_VERSION "${ZNC_VERSION}")

# https://cmake.org/pipermail/cmake/2010-September/039388.html
set(_all_targets "" CACHE INTERNAL "")
function(znc_add_library name)
	add_library("${name}" ${ARGN})
	set(_all_targets "${_all_targets};${name}" CACHE INTERNAL "")
endfunction()
function(znc_add_executable name)
	add_executable("${name}" ${ARGN})
	set(_all_targets "${_all_targets};${name}" CACHE INTERNAL "")
endfunction()
function(znc_add_custom_target name)
	add_custom_target("${name}" ${ARGN})
	set(_all_targets "${_all_targets};${name}" CACHE INTERNAL "")
endfunction()

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(TestCXX17)
if(NOT CYGWIN)
	# We don't want to use -std=gnu++17 instead of -std=c++17, but among other
	# things, -std=c++17 on cygwin defines __STRICT_ANSI__ which makes cygwin
	# not to compile: undefined references to strerror_r, to fdopen, to
	# strcasecmp, etc (their declarations in system headers are between ifdef)
	set(CMAKE_CXX_EXTENSIONS false)
endif()

include(CMakeFindFrameworks_fixed)
include(use_homebrew)
include(GNUInstallDirs)
include(CheckCXXSymbolExists)
include(copy_csocket)

set(CMAKE_THREAD_PREFER_PTHREAD true)
set(THREADS_PREFER_PTHREAD_FLAG true)
find_package(Threads REQUIRED)
if(NOT CMAKE_USE_PTHREADS_INIT)
	message(FATAL_ERROR "This compiler/OS doesn't seem to support pthreads.")
endif()

include(TestLargeFiles)
test_large_files(HAVE_LARGE_FILES_UNUSED_VAR)
find_package(PkgConfig)

macro(tristate_option opt help)
	set(WANT_${opt} AUTO CACHE STRING ${help})
	set_property(CACHE WANT_${opt} PROPERTY STRINGS AUTO YES NO)
	if(WANT_${opt} STREQUAL "AUTO")
		set(TRISTATE_${opt}_REQUIRED)
	else()
		set(TRISTATE_${opt}_REQUIRED REQUIRED)
	endif()
endmacro()

set(ZNC_CMAKE_FIND_DEPS "")
set(zncpubdeps)

tristate_option(OPENSSL "Support SSL")
if(WANT_OPENSSL)
	find_package(OpenSSL ${TRISTATE_OPENSSL_REQUIRED})

	if(OPENSSL_FOUND)
		# SSL_SESSION was made opaque in OpenSSL 1.1.0;
		# LibreSSL gained that function later too.
		# TODO: maybe remove this check at some point, and stop supporting old
		# libssl versions
		function(check_SSL_SESSION_get0_cipher)
			set(CMAKE_REQUIRED_LIBRARIES ${OPENSSL_LIBRARIES})
			set(CMAKE_REQUIRED_INCLUDES ${OPENSSL_INCLUDE_DIR})
			check_cxx_symbol_exists(SSL_SESSION_get0_cipher openssl/ssl.h
				HAVE_SSL_SESSION_get0_cipher)
		endfunction()
		check_SSL_SESSION_get0_cipher()
		set(ZNC_CMAKE_FIND_DEPS
			"${ZNC_CMAKE_FIND_DEPS}\nfind_dependency(OpenSSL)")
		list(APPEND zncpubdeps OpenSSL::SSL)
	endif()
endif()
set(HAVE_LIBSSL "${OPENSSL_FOUND}")

set(WANT_IPV6 true CACHE BOOL "Support IPv6")
set(HAVE_IPV6 "${WANT_IPV6}")

tristate_option(ZLIB "Compress HTTP traffic with Zlib")
if(WANT_ZLIB)
	find_package(ZLIB ${TRISTATE_ZLIB_REQUIRED})
endif()
set(HAVE_ZLIB "${ZLIB_FOUND}")

tristate_option(CYRUS "Support authentication with Cyrus")
if(WANT_CYRUS)
	pkg_check_modules(CYRUS IMPORTED_TARGET libsasl2)
	if(NOT CYRUS_FOUND)
		# libsasl2.pc is missing on 2.1.25 which is on ubuntu 14.04
		# next ubuntu version has 2.1.26 which has libsasl2.pc
		#
		# osx (as of El Capitan) doesn't have it either...
		set(_old_cmake_required_libraries "${CMAKE_REQUIRED_LIBRARIES}")
		set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} -lsasl2)
		# sys/types.h here is workaround for sasl 2.1.26:
		# https://github.com/znc/znc/issues/1243
		# https://lists.andrew.cmu.edu/pipermail/cyrus-sasl/2012-December/002572.html
		# https://cgit.cyrus.foundation/cyrus-sasl/commit/include/sasl.h?id=2f740223fa1820dd71e6ab0e50d4964760789209
		check_cxx_symbol_exists(sasl_server_init "sys/types.h;sasl/sasl.h"
			CYRUS_HARDCODED)
		set(CMAKE_REQUIRED_LIBRARIES "${_old_cmake_required_libraries}")
		if(CYRUS_HARDCODED)
			add_library(HardcodedCyrusDep INTERFACE)
			add_library(PkgConfig::CYRUS ALIAS HardcodedCyrusDep)
			target_link_libraries(HardcodedCyrusDep INTERFACE sasl2)
			set(CYRUS_FOUND true)
		endif()
	endif()
	if(TRISTATE_CYRUS_REQUIRED AND NOT CYRUS_FOUND)
		message(FATAL_ERROR "Can't find Cyrus SASL 2")
	endif()
endif()

tristate_option(ARGON "Store password hashes using Argon2id instead of SHA-256")
if(WANT_ARGON)
	pkg_check_modules(ARGON ${TRISTATE_ARGON_REQUIRED} IMPORTED_TARGET libargon2)
endif()
set(ZNC_HAVE_ARGON "${ARGON_FOUND}")

tristate_option(ICU "Support character encodings")
if(WANT_ICU)
	pkg_check_modules(ICU ${TRISTATE_ICU_REQUIRED} IMPORTED_TARGET icu-uc)
endif()
set(HAVE_ICU "${ICU_FOUND}")
if(ICU_FOUND)
	set(ZNC_CMAKE_FIND_DEPS "${ZNC_CMAKE_FIND_DEPS}\nfind_dependency_pc(ICU icu-uc)")
	list(APPEND zncpubdeps PkgConfig::ICU)
endif()

set(WANT_PERL false CACHE BOOL "Support Perl modules")
set(WANT_PYTHON false CACHE BOOL "Support Python modules")
set(WANT_PYTHON_VERSION "python3" CACHE STRING
	"Python version to use, e.g. python-3.5, this name is passed to pkg-config")
if(WANT_PYTHON AND NOT ICU_FOUND)
	message(FATAL_ERROR "Modpython requires ZNC to be compiled with charset "
	"support, but ICU library not found")
endif()
tristate_option(SWIG "Use SWIG to generate modperl and modpython")
set(search_swig false)
if(WANT_SWIG AND TRISTATE_SWIG_REQUIRED)
	set(search_swig true)
endif()
if(WANT_PERL AND NOT EXISTS
		"${PROJECT_SOURCE_DIR}/modules/modperl/generated.tar.gz")
	if(WANT_SWIG)
		set(search_swig true)
	else()
		message(FATAL_ERROR "Pregenerated modperl files are not available. "
			"SWIG is required. Alternatively, build ZNC from tarball.")
	endif()
endif()
if(WANT_PYTHON AND NOT EXISTS
		"${PROJECT_SOURCE_DIR}/modules/modpython/generated.tar.gz")
	if(WANT_SWIG)
		set(search_swig true)
	else()
		message(FATAL_ERROR "Pregenerated modpython files are not available. "
			"SWIG is required. Alternatively, build ZNC from tarball.")
	endif()
endif()
if(search_swig)
	find_package(SWIG 4.0.1)
	if(NOT SWIG_FOUND)
		message(FATAL_ERROR
			"Can't find SWIG, therefore Perl and Python aren't supported. "
			"Alternatively, build ZNC from tarball.")
	endif()
endif()

if(WANT_PERL)
	find_package(PerlLibs 5.10 REQUIRED)
endif()
if (WANT_PYTHON)
	set (_MIN_PYTHON_VERSION 3.4)
	find_package(Perl 5.10 REQUIRED)
	# VERSION_GREATER_EQUAL is available only since 3.7
	if (CMAKE_VERSION VERSION_LESS 3.12)
	else()
		# Even if FindPython3 is available (since CMake 3.12) we still use
		# pkg-config, because FindPython has a hardcoded list of python
		# versions, which may become outdated when new pythons are released,
		# but when cmake in the distro is old.
		#
		# Why FindPython3 is useful at all? Because sometimes there is no
		# python3.pc, but only python-3.5.pc and python-3.6.pc; which would
		# force user to provide the version explicitly via
		# WANT_PYTHON_VERSION. This is the case on Gentoo when NOT building
		# via emerge.
		if (WANT_PYTHON_VERSION STREQUAL "python3")
			find_package(Python3 COMPONENTS Development)
		else()
			# We used to pass value like "python-3.5" to the variable.
			if (WANT_PYTHON_VERSION MATCHES "^(python-)?(.*)$")
				find_package(Python3 COMPONENTS Development
					EXACT "${CMAKE_MATCH_2}")
			else()
				message(FATAL_ERROR "Invalid value of WANT_PYTHON_VERSION")
			endif()
		endif()
		if (Python3_FOUND AND Python3_VERSION VERSION_LESS
				${_MIN_PYTHON_VERSION})
			message(STATUS
				"Python too old, need at least ${_MIN_PYTHON_VERSION}")
			set(Python3_FOUND OFF)
		else()
			# Compatibility with pkg-config variables
			set(Python3_LDFLAGS "${Python3_LIBRARIES}")
		endif()
	endif()
	if (NOT Python3_FOUND AND WANT_PYTHON_VERSION MATCHES "^python")
		# Since python 3.8, -embed is required for embedding.
		pkg_check_modules(Python3
			"${WANT_PYTHON_VERSION}-embed >= ${_MIN_PYTHON_VERSION}")
		if (NOT Python3_FOUND)
			pkg_check_modules(Python3
				"${WANT_PYTHON_VERSION} >= ${_MIN_PYTHON_VERSION}")
		endif()
	endif()
	if (NOT Python3_FOUND)
		message(FATAL_ERROR "Python 3 is not found. Try disabling it.")
	endif()
endif()

set(WANT_TCL false CACHE BOOL "Support Tcl modules")
if(WANT_TCL)
	find_package(TCL QUIET)
	if(NOT TCL_FOUND)
		message(FATAL_ERROR "Can't find Tcl")
	endif()
endif()

tristate_option(I18N "Native language support (i18n)")
if(WANT_I18N)
	find_package(Boost ${TRISTATE_I18N_REQUIRED} COMPONENTS locale)
	find_package(Gettext ${TRISTATE_I18N_REQUIRED})
endif()
if(Boost_LOCALE_FOUND AND GETTEXT_MSGFMT_EXECUTABLE)
	set(HAVE_I18N true)
else()
	set(HAVE_I18N false)
	message(STATUS "Boost.Locale or gettext (msgfmt) is not found, disabling i18n support")
endif()

if(HAVE_I18N AND GETTEXT_MSGMERGE_EXECUTABLE)
	find_program(XGETTEXT_EXECUTABLE xgettext)
	if(XGETTEXT_EXECUTABLE)
		add_custom_target(translation)
	endif()
endif()

# poll() is broken on Mac OS, it fails with POLLNVAL for pipe()s.
if(APPLE)
	set(CSOCK_USE_POLL false)
else()
	set(CSOCK_USE_POLL true)
endif()

find_package(cctz QUIET)
set(cctz_cc "")
if (cctz_FOUND)
	message(STATUS "Found cctz at ${cctz_DIR}")
else()
	message(STATUS "Will build cctz")
	set(cctz_cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/civil_time_detail.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_fixed.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_format.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_if.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_impl.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_info.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_libc.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_lookup.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/time_zone_posix.cc
		${PROJECT_SOURCE_DIR}/third_party/cctz/src/zone_info_source.cc
	)
	add_library(cctz INTERFACE)
	add_library(cctz::cctz ALIAS cctz)
	target_include_directories(cctz INTERFACE
		$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/third_party/cctz/include>)
	if (APPLE)
		find_library(CoreFoundation CoreFoundation REQUIRED)
		target_link_libraries(cctz INTERFACE ${CoreFoundation})
	endif()
endif()

check_cxx_symbol_exists(getopt_long "getopt.h" HAVE_GETOPT_LONG)
check_cxx_symbol_exists(lstat "sys/types.h;sys/stat.h;unistd.h" HAVE_LSTAT)
check_cxx_symbol_exists(getpassphrase "stdlib.h" HAVE_GETPASSPHRASE)
check_cxx_symbol_exists(tcsetattr "termios.h;unistd.h" HAVE_TCSETATTR)
check_cxx_symbol_exists(clock_gettime "time.h" HAVE_CLOCK_GETTIME)

# Note that old broken systems, such as OpenBSD, NetBSD, which don't support
# AI_ADDRCONFIG, also have thread-unsafe getaddrinfo(). Gladly, they fixed
# thread-safety before support of AI_ADDRCONFIG, so this can be abused to
# detect the thread-safe getaddrinfo().
#
# TODO: drop support of blocking DNS at some point. OpenBSD supports
# AI_ADDRCONFIG since Nov 2014, and their getaddrinfo() is thread-safe since
# Nov 2013. NetBSD's one is thread-safe since ages ago.
check_cxx_symbol_exists(AI_ADDRCONFIG "sys/types.h;sys/socket.h;netdb.h"
	HAVE_THREADED_DNS)

if(CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CYGWIN)
	# These enable some debug options in g++'s STL, e.g. invalid use of
	# iterators, but they cause crashes on cygwin while loading modules
	set(_GLIBCXX_DEBUG true)
	set(_GLIBCXX_DEBUG_PEDANTIC true)
endif()

if(append_git_version)
	find_package(Git)
endif()

=== zz_msg/CMakeLists.txt ===
#
# Copyright (C) 2004-2024 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# This is implementation detail of CMake, but this install() runs last.
# Details are at https://cmake.org/pipermail/cmake/2011-July/045615.html

install(CODE "message(\"
******************************************************************
 ZNC was successfully installed.
 You can use '${CMAKE_INSTALL_FULL_BINDIR}/znc --makeconf'
 to generate a config file.

 If you need help with using ZNC, please visit our wiki at:
   http://znc.in\")")

=== cmake/perl_check/CMakeLists.txt ===
#
# Copyright (C) 2004-2024 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.13)
project(perl_check LANGUAGES CXX)
set(CMAKE_VERBOSE_MAKEFILE true)

if(APPLE)
	set(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS
		"${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
endif()

add_library(main MODULE main.cpp)
target_include_directories(main PRIVATE ${PERL_INCLUDE_DIRS})
target_compile_options(main PRIVATE "${PERL_CFLAGS}")
target_link_libraries(main PRIVATE ${PERL_LIBRARIES})
set_target_properties(main PROPERTIES LINK_FLAGS "${PERL_LDFLAGS}")

=== modules/modtcl/CMakeLists.txt ===
#
# Copyright (C) 2004-2024 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set(modinclude_modtcl PRIVATE ${TCL_INCLUDE_PATH} PARENT_SCOPE)
set(modlink_modtcl PRIVATE ${TCL_LIBRARY} PARENT_SCOPE)

install(FILES "modtcl.tcl" "binds.tcl"
	DESTINATION "${CMAKE_INSTALL_DATADIR}/znc/modtcl")

=== modules/po/CMakeLists.txt ===
#
# Copyright (C) 2004-2024 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include(translation)

foreach(modpath ${actual_modules})
	get_filename_component(mod "${modpath}" NAME_WE)
	get_filename_component(module "${modpath}" NAME)
	translation(SHORT "${mod}" FULL "znc-${mod}" SOURCES "${module}"
		TMPLDIRS "${CMAKE_CURRENT_SOURCE_DIR}/../data/${mod}/tmpl")
endforeach()

=== src/po/CMakeLists.txt ===
#
# Copyright (C) 2004-2024 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include(translation)

set(tmpl_dirs)
file(GLOB skins "${PROJECT_SOURCE_DIR}/webskins/*")
foreach(skin ${skins})
	list(APPEND tmpl_dirs "${skin}/tmpl")
endforeach()
translation(SHORT "znc" FULL "znc" SOURCES ${znc_cpp}
	TMPLDIRS ${tmpl_dirs})

=== test/integration/CMakeLists.txt ===
#
# Copyright (C) 2004-2024 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.13)
project(ZNCIntegrationTest LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED true)

set(CMAKE_THREAD_PREFER_PTHREAD true)
set(THREADS_PREFER_PTHREAD_FLAG true)
find_package(Threads REQUIRED)

find_package(Qt5Network 5.4 REQUIRED HINTS ${Qt5_HINTS})

# Force the simple internal regex engine to get consistent behavior on all
# platforms. See
# https://code.google.com/p/chromium/issues/detail?id=317224 for more details.
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS
	"GTEST_HAS_POSIX_RE=0")

add_executable(inttest
	"framework/main.cpp"
	"framework/base.cpp"
	"framework/znctest.cpp"
	"tests/core.cpp"
	"tests/modules.cpp"
	"tests/scripting.cpp"
	"${GTEST_ROOT}/src/gtest-all.cc"
	"${GMOCK_ROOT}/src/gmock-all.cc")

target_link_libraries(inttest Qt5::Network Threads::Threads)
target_include_directories(inttest PUBLIC
	"${PROJECT_SOURCE_DIR}/framework"
	"${GTEST_ROOT}" "${GTEST_ROOT}/include"
	"${GMOCK_ROOT}" "${GMOCK_ROOT}/include")
target_compile_definitions(inttest PRIVATE
	"ZNC_BIN_DIR=\"${ZNC_BIN_DIR}\"")

=== debian/changelog ===
znc (1.9.0-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:55:35 +1100

znc (1.9.0-2build2) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:09:20 +0000

znc (1.9.0-2build1) noble; urgency=medium

  * No-change rebuild against libperl5.38t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Mar 2024 18:24:06 +0000

znc (1.9.0-2) unstable; urgency=medium

  * Use argon2 for password hashing.
    Closes: #1065379

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 04 Mar 2024 11:09:56 +0100

znc (1.9.0-1) unstable; urgency=medium

  * New upstream release.
    - Add corecaps module.
  * Update debian/copyright.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 01 Mar 2024 11:39:35 +0100

=== debian/control ===
Source: znc
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Uploaders: Mattia Rizzolo <mattia@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-python,
 cmake,
 google-mock,
 googletest,
 pkg-config,
 swig,
 libargon2-dev,
 libboost-all-dev,
 libcurl4-openssl-dev,
 libssl-dev,
 libperl-dev,
 libicu-dev,
 libsasl2-dev,
 zlib1g-dev,
 tcl-dev,
 python3-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.znc.in/

Package: znc
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 openssl
Recommends: znc-tcl,
 znc-perl,
 znc-python
Conflicts: znc-webadmin,
 znc-extra
Breaks: znc-extra (<< ${binary:Version})
Replaces: znc-webadmin,
 znc-extra
Description: advanced modular IRC bouncer
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.

Package: znc-dev
Architecture: any
Depends: ${misc:Depends},
 ${python3:Depends},
 znc (>= ${binary:Version}),
 cmake,
 libicu-dev,
 libssl-dev,
 pkg-config,
 tcl-dev,
 python3-dev
Recommends: g++
Description: advanced modular IRC bouncer (development headers)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc development headers for developing modules.

Package: znc-perl
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 znc (= ${binary:Version})
Description: advanced modular IRC bouncer (Perl extension)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc Perl extension.

Package: znc-python
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 znc (= ${binary:Version})
Description: advanced modular IRC bouncer (Python extension)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc Python extension.

Package: znc-tcl
Section: interpreters
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 znc (= ${binary:Version})
Description: advanced modular IRC bouncer (Tcl extension)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc Tcl extension.

Package: znc-push
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 znc (= ${binVer}),
Enhances: znc
Homepage: https://github.com/jreese/znc-push
Description: znc plugin to send push notification to various services
 ZNC Push is a third party ZNC module that will send notifications to
 multiple push  notification services, or SMS for any private message or
 channel highlight that matches a configurable set of conditions.
 .
 ZNC Push current supports the following services:
  * Boxcar
  * Boxcar 2
  * Pushover
  * Pushsafer
  * Prowl
  * Supertoasty
  * PushBullet
  * Airgram
  * Faast
  * Nexmo
  * Pushalot
  * Pushjet
  * Telegram
  * Custom URL GET requests
 .
 For more information about ZNC, see the znc package.

Package: znc-backlog
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 znc (= ${binVer}),
Enhances: znc
Homepage: https://github.com/FruitieX/znc-backlog
Description: module for requesting backlog from znc bouncer
 znc-backlog is a third party ZNC module that makes it easy to request backlog.
 Its intended use is for when you have just launched your IRC client and gotten
 a few lines of backlog sent to you, but want to read more. Instead of having
 to deal with shelling into the box where you run ZNC and manually sifting
 through the logs, you can issue a short command in your IRC client to request
 any amount of the most recent lines of log.
 .
 For more information about ZNC, see the znc package.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_REVISION ?= "+deb$(shell echo $(DEB_VERSION) | cut -d- -f2)"

znc_backlog_pth = $(CURDIR)/debian/contrib/znc-backlog
znc_backlog_ver = 0.20180824+$(DEB_VERSION)
znc_push_pth = $(CURDIR)/debian/contrib/znc-push
znc_push_ver = 1.0.0+git20190521.78d0385+$(DEB_VERSION)

DEB_CONFIGURE_EXTRA_FLAGS := \
	-DCMAKE_INSTALL_LIBDIR=lib \
	-DVERSION_EXTRA=$(DEB_REVISION) \
	-DGTEST_ROOT="/usr/src/googletest/googletest" \
	-DGMOCK_ROOT="/usr/src/googletest/googlemock" \
	-DWANT_SYSTEMD=false \
	-DWANT_TCL=true \
	-DWANT_CYRUS=true \
	-DWANT_PYTHON=true \
	-DWANT_PERL=true \
	-DWANT_I18N=true

export VERBOSE=1

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --buildsystem=makefile -D$(znc_backlog_pth)
	dh_auto_clean --buildsystem=makefile -D$(znc_push_pth)

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

build_contrib_plugins: export PATH := $(CURDIR)/debian/tmp/usr/bin:$(PATH)
build_contrib_plugins: export CXXFLAGS += -I$(CURDIR)/debian/tmp/usr/include
build_contrib_plugins: export CMAKE_PREFIX_PATH := $(CURDIR)/debian/tmp/usr/share/znc/cmake
build_contrib_plugins:
	dh_auto_build --buildsystem=makefile -D$(znc_backlog_pth)
	dh_auto_build --buildsystem=makefile -D$(znc_push_pth) -- \
		version="$(znc_push_ver)" curl=yes

override_dh_installsystemd:
	dh_installsystemd --no-start --no-enable --restart-after-upgrade

override_dh_python3:
	dh_python3 \
		-p znc-python \
		--exclude=znc.py \
		--exclude=znc_core.py

override_dh_install: build_contrib_plugins
	dh_install
	dh_install -p znc-dev \
		usr/lib/pkgconfig/* usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
	# Fix pkg-config file.
	sed '/^Cflags:/d' -i $(CURDIR)/debian/znc-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/znc.pc
	sed '/Libs:/d' -i $(CURDIR)/debian/znc-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/znc.pc

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs -pznc-backlog -XChangeLog.md
	dh_installchangelogs -pznc-push -XChangeLog.md
	dh_installchangelogs --remaining-packages

override_dh_gencontrol:
	dh_gencontrol -pznc-backlog -- -v$(znc_backlog_ver) -VbinVer=$(DEB_VERSION)
	dh_gencontrol -pznc-push -- -v$(znc_push_ver) -VbinVer=$(DEB_VERSION)
	dh_gencontrol --remaining-packages
